Loading...
Searching...
No Matches
hueplusplus::sensors::CLIPOpenClose Class Reference

CLIP sensor detecting whether a contact is open or closed. More...

`#include <hueplusplus/CLIPSensors.h>`

Inheritance diagram for hueplusplus::sensors::CLIPOpenClose:
[legend]
Collaboration diagram for hueplusplus::sensors::CLIPOpenClose:
[legend]

## Public Member Functions

| CLIPOpenClose (Sensor sensor)
| Construct from generic sensor.
bool | isOpen () const
| Check whether the switch is open.
void | setOpen (bool open)
| Set switch state.
Public Member Functions inherited from hueplusplus::sensors::BaseCLIP
bool | isOn () const
| Check if sensor is on.
void | setOn (bool on)
| Enable or disable sensor.
bool | hasBatteryState () const
| Check whether the sensor has a battery state.
int | getBatteryState () const
| Get battery state.
void | setBatteryState (int percent)
| Set battery state.
bool | isReachable () const
| Check whether the sensor is reachable.
bool | hasURL () const
| Check whether the sensor has a URL.
std::string | getURL () const
| Get sensor URL.
void | setURL (const std::string &url)
| Set sensor URL.
time::AbsoluteTime | getLastUpdated () const
| Get time of last status update.
Public Member Functions inherited from hueplusplus::BaseDevice
virtual | ~BaseDevice ()=default
| Virtual destructor.
virtual int | getId () const
| Const function that returns the id of this device.
virtual std::string | getType () const
| Const function that returns the device type.
virtual std::string | getName ()
| Function that returns the name of the device.
virtual std::string | getName () const
| Const function that returns the name of the device.
virtual std::string | getModelId () const
| Const function that returns the modelid of the device.
virtual std::string | getUId () const
| Const function that returns the uniqueid of the device.
virtual std::string | getManufacturername () const
| Const function that returns the manufacturername of the device.
virtual std::string | getProductname () const
| Const function that returns the productname of the device.
virtual std::string | getSwVersion ()
| Function that returns the software version of the device.
virtual std::string | getSwVersion () const
| Const function that returns the software version of the device.
virtual bool | setName (const std::string &name)
| Function that sets the name of the device.
virtual void | refresh (bool force=false)
| Refreshes internal cached state.
virtual void | setRefreshDuration (std::chrono::steady_clock::duration refreshDuration)
| Sets custom refresh interval for this device.

## Static Public Attributes

static constexpr const char * | typeStr = "CLIPOpenClose"
| CLIPOpenClose sensor type name.

## Additional Inherited Members

Protected Member Functions inherited from hueplusplus::sensors::BaseCLIP
| BaseCLIP (Sensor sensor)
| Protected constructor to be used by subclasses.
Protected Member Functions inherited from hueplusplus::BaseDevice
| BaseDevice (int id, const std::shared_ptr< APICache > &baseCache)
| Protected ctor that is used by subclasses, construct with shared cache.
| BaseDevice (int id, const HueCommandAPI &commands, const std::string &path, std::chrono::steady_clock::duration refreshDuration, const nlohmann::json &currentState)
| Protected ctor that is used by subclasses.
virtual nlohmann::json | sendPutRequest (const std::string &subPath, const nlohmann::json &request, FileInfo fileInfo)
| Utility function to send a put request to the device.
Protected Attributes inherited from hueplusplus::BaseDevice
int | id
| holds the id of the device
APICache | state
| holds the current state of the device

## Detailed Description

CLIP sensor detecting whether a contact is open or closed.

## Constructor & Destructor Documentation

## CLIPOpenClose()

hueplusplus::sensors::CLIPOpenClose::CLIPOpenClose | ( | Sensor | sensor | ) |

inline explicit

Construct from generic sensor.

## Member Function Documentation

## isOpen()

bool hueplusplus::sensors::CLIPOpenClose::isOpen | ( |  | ) | const

Check whether the switch is open.

## setOpen()

void hueplusplus::sensors::CLIPOpenClose::setOpen | ( | bool | open | ) |

Set switch state.

The sensor needs to stay in a state for at least 1s.

Exceptions

  std::system_error | when system or socket operations fail
  HueException | when response contained no body
  HueAPIResponseException | when response contains an error
  nlohmann::json::parse_error | when response could not be parsed

## Member Data Documentation

## typeStr

const char * hueplusplus::sensors::CLIPOpenClose::typeStr = "CLIPOpenClose"

static constexpr

CLIPOpenClose sensor type name.

The documentation for this class was generated from the following files:

- include/hueplusplus/CLIPSensors.h
- src/CLIPSensors.cpp